# -*- coding: utf-8 -*-

import MySQLdb


class Baza_danych():
	
	user = "tomek"
	passwd = "tomek"
	charset = "utf8"
	database = "moje_wydatki"
	table = "wydatki"
	
	lista_kategorii = []
	
	def __init__(self):
		self.pobranie_listy_kategorii()
			
	def __polaczenie_z_baza_danych(self):
		#------------------------------------------------------------------------
		# cześć służąca do połączenia się z serwerem i ustawienie cursora

		self.DB = MySQLdb.connect(user=self.user, passwd=self.passwd, charset=self.charset)

		self.DBcursor = self.DB.cursor()
		
		# każe zastosować wcześniej stworzoną bazę danych "moje_wydatki"
		self.DBcursor.execute("USE %s" % self.database)
		
		#------------------------------------------------------------------------
	
	def __zapytanie_o_aktualna_date(self):
		#------------------------------------------------------------------------

		# pobieram aktualną date z serwera - przy zapisie do bazy można użyć "NOW()" ale będzie to zwracało ostrzeżenie
		# można również pobrać czas - dzięki czemu data i czas zapisu są zawsze jak na serwerze
		self.DBcursor.execute("SELECT CURDATE()")
		date = self.DBcursor.fetchall()
		self.aktualna_data = date[0][0]

		#------------------------------------------------------------------------
		# by wygodniej korzystać z daty warto ja zapisać w liście
		self.aktualna_data_w_liscie = str(self.aktualna_data).split("-")
		
	
	def zapis_do_bazy(self, kategoria_wydatku, wartosc_wydatku, opis):
		
		self.__polaczenie_z_baza_danych()

		# zapytanie o aktualna datę - tak by posiadać taką samą ja na serwerze
		self.__zapytanie_o_aktualna_date()

		# jeśli nic nie wpisano w opisie wówczas w opisie wstawia się NULL
		if len(opis) == 0:
				self.command = "INSERT %s (kategoria_wydatku, data, wartosc_wydatku) VALUES (%s, '%s', %s)" % ( self.table, kategoria_wydatku, self.aktualna_data, wartosc_wydatku)
		else:
				self.command = "INSERT %s (kategoria_wydatku, data, wartosc_wydatku, opis) VALUES (%s, '%s', %s, '%s')" % ( self.table, kategoria_wydatku, self.aktualna_data, wartosc_wydatku, opis)


		self.DBcursor.execute(self.command)

		#------------------------------------------------------------------------
		#commit bazy i jej zamknięcie - bez tego dane nie zostaną zapisane - taki typ engina

		self.DB.commit()

		self.DB.close()
	
	
	def polaczenie_z_baza_i_zapytanie_o_date(self):
		self.__polaczenie_z_baza_danych()
		self.__zapytanie_o_aktualna_date()
		
	def wyslanie_zapytania_o_sume_zamkniecie_bazy(self):
		self.DBcursor.execute(self.command)
		
		self.suma = self.DBcursor.fetchall()[0][0]
		
		if type(self.suma) == float or type(self.suma) == int :
			self.suma = round(self.suma,2)
		else:
			self.suma = 0.
		
		self.DB.close()
		
		
	def suma_wydatkow_z_aktualnego_miesiaca(self):
		
		self.polaczenie_z_baza_i_zapytanie_o_date()
			
		self.command = "SELECT SUM(wartosc_wydatku) FROM wydatki WHERE data > '%s-%s-01'" % (self.aktualna_data_w_liscie[0], self.aktualna_data_w_liscie[1])
		
		self.wyslanie_zapytania_o_sume_zamkniecie_bazy()
		
		return(self.suma)
		
		
	def suma_wydatkow_z_aktualnego_roku(self):
		
		self.polaczenie_z_baza_i_zapytanie_o_date()
		
		self.command = "SELECT SUM(wartosc_wydatku) FROM wydatki WHERE data > '%s-01-01'" % self.aktualna_data_w_liscie[0]
		
		self.wyslanie_zapytania_o_sume_zamkniecie_bazy()
		
		return(self.suma)
		
	def wszystkie_wydatki(self):
		
		self.__polaczenie_z_baza_danych()
		
		self.command = "SELECT SUM(wartosc_wydatku) FROM wydatki"
		
		self.wyslanie_zapytania_o_sume_zamkniecie_bazy()
		
		return(self.suma)
		
		
	def suma_wydatkow_z_aktualnego_miesiaca_na_dana_kategorie(self, nazwa_kategorii):
		
		self.polaczenie_z_baza_i_zapytanie_o_date()
			
		self.command = "SELECT SUM(wartosc_wydatku) FROM wydatki, kategoria_wydatkow WHERE (kategoria_wydatku = kategoria_wydatkow_id) AND "
		self.command += "(nazwa='%s') AND " % nazwa_kategorii
		self.command += "(data > '%s-%s-01')" % (self.aktualna_data_w_liscie[0], self.aktualna_data_w_liscie[1])
		
		self.wyslanie_zapytania_o_sume_zamkniecie_bazy()
		
		return(self.suma)
		
		
		
	def suma_wydatkow_z_aktualnego_roku_na_dana_kategorie(self, nazwa_kategorii):
		
		self.polaczenie_z_baza_i_zapytanie_o_date()
			
		self.command = "SELECT SUM(wartosc_wydatku) FROM wydatki, kategoria_wydatkow WHERE (kategoria_wydatku = kategoria_wydatkow_id) AND "
		self.command += "(nazwa='%s') AND " % nazwa_kategorii
		self.command += "(data > '%s-01-01')" % self.aktualna_data_w_liscie[0]
		
		self.wyslanie_zapytania_o_sume_zamkniecie_bazy()
		
		return(self.suma)
		
		
	def suma_wydatkow_na_dana_kategorie(self, nazwa_kategorii):
		
		self.__polaczenie_z_baza_danych()
			
		self.command = "SELECT SUM(wartosc_wydatku) FROM wydatki, kategoria_wydatkow WHERE (kategoria_wydatku = kategoria_wydatkow_id) AND "
		self.command += "(nazwa='%s')" % nazwa_kategorii
				
		self.wyslanie_zapytania_o_sume_zamkniecie_bazy()
		
		return(self.suma)
		
		
	def pobranie_listy_kategorii(self):
		self.__polaczenie_z_baza_danych()
		
		self.command = "SELECT nazwa FROM kategoria_wydatkow"
		
		self.DBcursor.execute(self.command)
		
		lista_kategorii_tymczasowa = self.DBcursor.fetchall()
		
		
		for i in range(len(lista_kategorii_tymczasowa)):
			self.lista_kategorii.append(unicode(lista_kategorii_tymczasowa[i][0]))
					
		self.DB.close()
		
		return()
		