#!/usr/bin/env python
# -*- coding: utf-8 -*-

import baza_danych
import sys
from PyQt4 import QtGui, QtCore


class WprowadzanieDanej(QtGui.QWidget):

    def __init__(self, nazwa_danej, wartosc_poczontkowa):      
        super(WprowadzanieDanej, self).__init__()
        
        self.vbox = QtGui.QVBoxLayout()
        self.dana_text = QtGui.QLabel(nazwa_danej, self)
        self.dana = QtGui.QDoubleSpinBox(self)
        #self.dana.setMaximum(100)
        self.dana.setMinimum(0)
        self.dana.setValue(wartosc_poczontkowa)
        self.vbox.addWidget(self.dana_text)
        self.vbox.addWidget(self.dana)
        self.setLayout(self.vbox)

class OknoGlowne(QtGui.QWidget):
	
	def __init__(self):
		super(OknoGlowne, self).__init__()
		
		self.setFixedSize(420, 480)
		self.setWindowTitle(u"BAZA DANYCH WYDATKÓW")
        
		# zaklatki
		tabwidget = QtGui.QTabWidget()
		tabwidget.setFixedSize(400, 450)
		self.zapis_wydatku = QtGui.QWidget()
		self.raporty = QtGui.QWidget()
		
		# nazwy zakladek
		tabwidget.addTab(self.zapis_wydatku, u"zapis wydatku")
		tabwidget.addTab(self.raporty, u"raporty")
		
		self.okienko_zapis_wydatku()
		self.okienko_raportu()
		
		vbox = QtGui.QHBoxLayout()
		vbox.addStretch(1)
		vbox.addWidget(tabwidget)
		self.setLayout(vbox)
		
		
	def okienko_zapis_wydatku(self):
		
		self.vbox = QtGui.QVBoxLayout(self.zapis_wydatku)
		
		#--------------------------------------------------------------------------------------
		self.kategoria = baza.lista_kategorii[0]
		self.kategorie = baza.lista_kategorii
		self.wybor_kategorii = QtGui.QComboBox(self)
				
		for i in self.kategorie:
			self.wybor_kategorii.addItem(i)
			
		self.vbox.addWidget(self.wybor_kategorii)
		#--------------------------------------------------------------------------------------
		
		self.wartosc_wydatku = WprowadzanieDanej(u"koszt, zł", 5.0)
		self.vbox.addWidget(self.wartosc_wydatku)
		
		#--------------------------------------------------------------------------------------
		
		self.opis = QtGui.QTextEdit('', self)
		self.vbox.addWidget(self.opis)
		
		#--------------------------------------------------------------------------------------
		
		self.pushButton = QtGui.QPushButton(u"ZAPISZ")
		self.vbox.addWidget(self.pushButton)
		
		self.connect(self.pushButton, QtCore.SIGNAL('clicked()'), self.zapisanie_w_bazie_danych)
	
	
	
	def zapisanie_w_bazie_danych(self):
		
		#wyszukanie numeru kategorii - ten kod trzeba zmienić by sczytywał z bazy, inaczej kategorie muszą byś jedna po drugiej bez przerw w numeracji
		for nr_kategorii in range(len(self.kategorie)):
			if self.kategorie[nr_kategorii] == unicode(self.wybor_kategorii.currentText()):
				nr_kategorii += 1
				break
		
		baza.zapis_do_bazy(kategoria_wydatku = nr_kategorii, wartosc_wydatku = self.wartosc_wydatku.dana.value(), opis = self.opis.toPlainText())
		
		
		
	def okienko_raportu(self):
		
		self.vbox1 = QtGui.QVBoxLayout(self.raporty)
		
		#--------------------------------------------------------------------------------------
		self.text_raportu = QtGui.QTextEdit('', self)
		self.vbox1.addWidget(self.text_raportu)
		#--------------------------------------------------------------------------------------
		
		self.pushButton1 = QtGui.QPushButton(u"POBIERZ RAPORT")
		self.vbox1.addWidget(self.pushButton1)
		
		self.connect(self.pushButton1, QtCore.SIGNAL('clicked()'), self.pobieranie_raportu)
		
	def pobieranie_raportu(self):
		text = u"wydatki w tym miesiącu = %s\n" % baza.suma_wydatkow_z_aktualnego_miesiaca()
		text += u"wydatki w tym roku = %s\n\n\n" % baza.suma_wydatkow_z_aktualnego_roku()
		
		
		for kategoria in self.kategorie:
			text +=  u"wydatki na %s\n" % kategoria
			text +=  u"wydatki w tym miesiącu = %s\n" % baza.suma_wydatkow_z_aktualnego_miesiaca_na_dana_kategorie(kategoria)
			text +=  u"wydatki w tym roku = %s\n\n\n" % baza.suma_wydatkow_z_aktualnego_roku_na_dana_kategorie(kategoria)
			
		self.text_raportu.setText(text)
		
		
		
app = QtGui.QApplication(sys.argv)
baza = baza_danych.Baza_danych()
icon = OknoGlowne()
icon.show()
app.exec_()